function distances = fastmarching(M, x0)
%FASTMARCHING Calculates the distance map of x0 on M. 

n = size(M.VERT,1);
m = size(M.TRIV,1);

incidence = incidenceMatrix(M.TRIV);

% inititialisations
heap = MinHeap(n);

heap.push(0, a);
for i=1:n
   heap.push(Inf, i); 
end

distances = -1*ones(n,1);

% run dijkstra
while(~heap.isEmpty())
   % your code here! you can modify march.m for the update step
end

end